package gomod

import (
	"fmt"
	"html/template"
	"net/http"
)

func Index(w http.ResponseWriter, r *http.Request) {
	r.ParseForm()
	t, err := template.ParseFiles("view/index.html")
	if err != nil {
		fmt.Fprintf(w, "parse template error: %s", err.Error())
		return
	}
	t.Execute(w, nil)
}

// ======================================No Reason Remittance======================================================
func Remit(w http.ResponseWriter, r *http.Request) {
	if r.Method == "GET" {
		t, err := template.ParseFiles("view/onlinepay/remit.html")
		if err != nil {
			fmt.Fprintf(w, "parse template error: %s", err.Error())
			return
		}
		t.Execute(w, nil)
	} else {
		RemitRequest(w, r)
	}
}
func Callback(w http.ResponseWriter, r *http.Request) {
	OrderCallback(w, r)
}
func Notify(w http.ResponseWriter, r *http.Request) {
	OrderNotify(w, r)
}
func Query(w http.ResponseWriter, r *http.Request) {
	if r.Method == "GET" {
		t, err := template.ParseFiles("view/onlinepay/query.html")
		if err != nil {
			fmt.Fprintf(w, "parse template error: %s", err.Error())
			return
		}
		t.Execute(w, nil)
	} else {
		QueryRequest(w, r)
	}
}
func RateQuery(w http.ResponseWriter, r *http.Request) {
	if r.Method == "GET" {
		t, err := template.ParseFiles("view/onlinepay/rateQuery.html")
		if err != nil {
			fmt.Fprintf(w, "parse template error: %s", err.Error())
			return
		}
		t.Execute(w, nil)
	} else {
		RateQueryRequest(w, r)
	}
}


// 模拟异步通知POST数据
func DataPost(w http.ResponseWriter, r *http.Request) {
	if r.Method == "GET" {
		t, err := template.ParseFiles("view/post.html")
		if err != nil {
			fmt.Fprintf(w, "parse template error: %s", err.Error())
			return
		}
		t.Execute(w, nil)
	} else {
		PostRequest(w, r)
	}
}

// 订单关闭
func Close(w http.ResponseWriter, r *http.Request) {
	if r.Method == "GET" {
		t, err := template.ParseFiles("view/onlinepay/close.html")
		if err != nil {
			fmt.Fprintf(w, "parse template error: %s", err.Error())
			return
		}
		t.Execute(w, nil)
	} else {
		CloseRequest(w, r)
	}
}
func CloseCallback(w http.ResponseWriter, r *http.Request) {
	closeCallback(w, r)
}
