package utils

import (
	"encoding/json"
	"io/ioutil"
	"net/http"
	"strings"
)

type ResponseBack struct {
	Data string `json:"data"`
}

func Post(url string, encryptKey string, merchantId string, requestId string, data string, path string, password string) (string, error) {
	client := &http.Client{}
	reqest, err := http.NewRequest("POST", url, strings.NewReader(data))
	if err != nil {
		return "", err
	}
	//增加header选项
	reqest.Header.Add("Content-Type", "application/vnd.geoswift-v3.0+json")
	reqest.Header.Add("encryptKey", encryptKey)
	reqest.Header.Add("merchantId", merchantId)
	reqest.Header.Add("requestId", requestId)

	resp, err := client.Do(reqest)
	if err != nil {
		return "", err
	}
	defer resp.Body.Close()
	body, err := ioutil.ReadAll(resp.Body)
	if err != nil {
		return "", err
	}
	rpencryptKey := IsNull(resp.Header["Encryptkey"])
	if rpencryptKey != "" {
		aeskey, err := PrivateDecrypt(rpencryptKey, path, password)
		if err != nil {
			return "", err
		}
		var rback ResponseBack
		json.Unmarshal(body, &rback)
		ret, err := AesECBDecrypt(rback.Data, aeskey)
		if err != nil {
			return "", err
		}
		return ret, err
	} else {
		return "NO Data", err
	}
}

func Post2(url string, encryptKey string, merchantId string, data string, path string, password string) (string, error) {
	client := &http.Client{}
	reqest, err := http.NewRequest("POST", url, strings.NewReader(data))
	if err != nil {
		return "", err
	}
	//增加header选项
	reqest.Header.Add("Content-Type", "application/vnd.geoswift-v3.0+json")
	reqest.Header.Add("encryptKey", encryptKey)
	reqest.Header.Add("merchantId", merchantId)

	resp, err := client.Do(reqest)
	if err != nil {
		return "", err
	}
	defer resp.Body.Close()
	body, err := ioutil.ReadAll(resp.Body)
	if err != nil {
		return "", err
	}
	rpencryptKey := IsNull(resp.Header["Encryptkey"])
	if rpencryptKey != "" {
		aeskey, err := PrivateDecrypt(rpencryptKey, path, password)
		if err != nil {
			return "", err
		}
		var rback ResponseBack
		json.Unmarshal(body, &rback)
		ret, err := AesECBDecrypt(rback.Data, aeskey)
		if err != nil {
			return "", err
		}
		return ret, err
	} else {
		return "NO Data", err
	}
}
